com.fasterxml.jackson.databind.deser.std

## Class StdNodeBasedDeserializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdNodeBasedDeserializer<T>

Type Parameters:
  `T` - Target type of this deserializer; that is, type of values that input data is deserialized into.

All Implemented Interfaces:
  NullValueProvider, ResolvableDeserializer, Serializable

    public abstract class StdNodeBasedDeserializer<T>
    extends StdDeserializer<T>
    implements ResolvableDeserializer

Convenience deserializer that may be used to deserialize values given an intermediate tree representation (`JsonNode`). Note that this is a slightly simplified alternative to `StdDelegatingDeserializer`).

Since:
  2.5
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected JsonDeserializer<Object>` `_treeDeserializer`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`protected` `StdNodeBasedDeserializer(Class<T> targetType)`
`protected` `StdNodeBasedDeserializer(JavaType targetType)`
`protected` `StdNodeBasedDeserializer(StdNodeBasedDeserializer<?> src)` "Copy-constructor" used when creating a modified copies, most often if sub-class implements `ContextualDeserializer`.

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract T` `convert(JsonNode root, DeserializationContext ctxt)`
`T` `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer td)` Base implementation that does not assume specific type inclusion mechanism.
`void` `resolve(DeserializationContext ctxt)` Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller.

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserialize, findBackReference, getDelegatee, getEmptyAccessPattern, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, supportsUpdate, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _treeDeserializer

    protected JsonDeserializer<Object> _treeDeserializer

### Constructor Detail

#### StdNodeBasedDeserializer

    protected StdNodeBasedDeserializer(JavaType targetType)

#### StdNodeBasedDeserializer

    protected StdNodeBasedDeserializer(Class<T> targetType)

#### StdNodeBasedDeserializer

    protected StdNodeBasedDeserializer(StdNodeBasedDeserializer<?> src)

"Copy-constructor" used when creating a modified copies, most often if sub-class implements `ContextualDeserializer`.

### Method Detail

#### resolve

    public void resolve(DeserializationContext ctxt)
                 throws JsonMappingException

Description copied from interface: `ResolvableDeserializer`
Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).

Specified by:
  `resolve` in interface `ResolvableDeserializer`
Parameters:
  `ctxt` - Context to use for accessing configuration, resolving secondary deserializers
Throws:
  `JsonMappingException`

#### convert

    public abstract T convert(JsonNode root,
                              DeserializationContext ctxt)
                       throws IOException

Throws:
  `IOException`

#### deserialize

    public T deserialize(JsonParser jp,
                         DeserializationContext ctxt)
                  throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.getCurrentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<T>`
Parameters:
  `jp` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser jp,
                                      DeserializationContext ctxt,
                                      TypeDeserializer td)
                               throws IOException,
                                      JsonProcessingException

Description copied from class: `StdDeserializer`
Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

Overrides:
  `deserializeWithType` in class `StdDeserializer<T>`
  `td` - Deserializer to use for handling type information
Throws:
  `IOException`
  `JsonProcessingException`